Clp 1.17.6

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Groups Pages
Public Member Functions | Protected Attributes | List of all members
OsiBranchingObject Class Referenceabstract

Abstract branching object base class. More...

`#include <OsiBranchingObject.hpp>`

Inheritance diagram for OsiBranchingObject:
[legend]
Collaboration diagram for OsiBranchingObject:
[legend]

## Public Member Functions
| OsiBranchingObject ()
| Default Constructor. More...
| OsiBranchingObject (OsiSolverInterface *solver, double value)
| Constructor. More...
| OsiBranchingObject (const OsiBranchingObject &)
| Copy constructor. More...
OsiBranchingObject & | operator= (const OsiBranchingObject &rhs)
| Assignment operator. More...
virtual OsiBranchingObject * | clone () const =0
| Clone. More...
virtual | ~OsiBranchingObject ()
| Destructor. More...
int | numberBranches () const
| The number of branch arms created for this branching object. More...
int | numberBranchesLeft () const
| The number of branch arms left for this branching object. More...
void | incrementNumberBranchesLeft ()
| Increment the number of branch arms left for this branching object. More...
void | setNumberBranchesLeft (int)
| Set the number of branch arms left for this branching object Just for forcing. More...
void | decrementNumberBranchesLeft ()
| Decrement the number of branch arms left for this branching object. More...
virtual double | branch (OsiSolverInterface *solver)=0
| Execute the actions required to branch, as specified by the current state of the branching object, and advance the object's state. More...
virtual double | branch ()
| Execute the actions required to branch, as specified by the current state of the branching object, and advance the object's state. More...
virtual bool | boundBranch () const
| Return true if branch should fix variables. More...
int | branchIndex () const
| Get the state of the branching object This is just the branch index. More...
void | setBranchingIndex (int branchIndex)
| Set the state of the branching object. More...
double | value () const
| Current value. More...
const OsiObject * | originalObject () const
| Return pointer back to object which created. More...
void | setOriginalObject (const OsiObject *object)
| Set pointer back to object which created. More...
virtual void | checkIsCutoff (double)
| Double checks in case node can change its mind! Returns objective value Can change objective etc. More...
int | columnNumber () const
| For debug. More...
virtual void | print (const OsiSolverInterface *=NULL) const
| Print something about branch - only if log level high. More...

## Protected Attributes
double | value_
| Current value - has some meaning about branch. More...
const OsiObject * | originalObject_
| Pointer back to object which created. More...
int | numberBranches_
| Number of branches. More...
short | branchIndex_
| The state of the branching object. More...

## Detailed Description

Abstract branching object base class.

In the abstract, an OsiBranchingObject contains instructions for how to branch. We want an abstract class so that we can describe how to branch on simple objects (e.g., integers) and more exotic objects (e.g., cliques or hyperplanes).

The branch() method is the crucial routine: it is expected to be able to step through a set of branch arms, executing the actions required to create each subproblem in turn. The base class is primarily virtual to allow for a wide range of problem modifications.

See OsiObject for an overview of the two classes (OsiObject and OsiBranchingObject) which make up Osi's branching model.

Definition at line 282 of file OsiBranchingObject.hpp.

## Constructor & Destructor Documentation

OsiBranchingObject::OsiBranchingObject | ( |  | ) |

Default Constructor.

OsiBranchingObject::OsiBranchingObject | ( | OsiSolverInterface * | solver,
|  | double | value
| ) |  |

Constructor.

OsiBranchingObject::OsiBranchingObject | ( | const OsiBranchingObject & |  | ) |

Copy constructor.

virtual OsiBranchingObject::~OsiBranchingObject | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

OsiBranchingObject& OsiBranchingObject::operator= | ( | const OsiBranchingObject & | rhs | ) |

Assignment operator.

virtual OsiBranchingObject* OsiBranchingObject::clone | ( |  | ) | const
| pure virtual

Clone.

Implemented in OsiLotsizeBranchingObject, OsiSOSBranchingObject, and OsiIntegerBranchingObject.

int OsiBranchingObject::numberBranches | ( |  | ) | const
| inline

The number of branch arms created for this branching object.

Definition at line 304 of file OsiBranchingObject.hpp.

int OsiBranchingObject::numberBranchesLeft | ( |  | ) | const
| inline

The number of branch arms left for this branching object.

Definition at line 310 of file OsiBranchingObject.hpp.

void OsiBranchingObject::incrementNumberBranchesLeft | ( |  | ) |
| inline

Increment the number of branch arms left for this branching object.

Definition at line 316 of file OsiBranchingObject.hpp.

void OsiBranchingObject::setNumberBranchesLeft | ( | int |  | ) |
| inline

Set the number of branch arms left for this branching object Just for forcing.

Definition at line 324 of file OsiBranchingObject.hpp.

void OsiBranchingObject::decrementNumberBranchesLeft | ( |  | ) |
| inline

Decrement the number of branch arms left for this branching object.

Definition at line 330 of file OsiBranchingObject.hpp.

virtual double OsiBranchingObject::branch | ( | OsiSolverInterface * | solver | ) |
| pure virtual

Execute the actions required to branch, as specified by the current state of the branching object, and advance the object's state.

Returns change in guessed objective on next branch

Implemented in OsiLotsizeBranchingObject, OsiSOSBranchingObject, OsiIntegerBranchingObject, and OsiTwoWayBranchingObject.

virtual double OsiBranchingObject::branch | ( |  | ) |
| inline virtual

Execute the actions required to branch, as specified by the current state of the branching object, and advance the object's state.

Returns change in guessed objective on next branch

Definition at line 346 of file OsiBranchingObject.hpp.

virtual bool OsiBranchingObject::boundBranch | ( |  | ) | const
| inline virtual

Return true if branch should fix variables.

Definition at line 349 of file OsiBranchingObject.hpp.

int OsiBranchingObject::branchIndex | ( |  | ) | const
| inline

Get the state of the branching object This is just the branch index.

Definition at line 356 of file OsiBranchingObject.hpp.

void OsiBranchingObject::setBranchingIndex | ( | int | branchIndex | ) |
| inline

Set the state of the branching object.

Definition at line 363 of file OsiBranchingObject.hpp.

double OsiBranchingObject::value | ( |  | ) | const
| inline

Current value.

Definition at line 369 of file OsiBranchingObject.hpp.

const OsiObject* OsiBranchingObject::originalObject | ( |  | ) | const
| inline

Return pointer back to object which created.

Definition at line 375 of file OsiBranchingObject.hpp.

void OsiBranchingObject::setOriginalObject | ( | const OsiObject * | object | ) |
| inline

Set pointer back to object which created.

Definition at line 380 of file OsiBranchingObject.hpp.

virtual void OsiBranchingObject::checkIsCutoff | ( | double |  | ) |
| inline virtual

Double checks in case node can change its mind! Returns objective value Can change objective etc.

Definition at line 387 of file OsiBranchingObject.hpp.

int OsiBranchingObject::columnNumber | ( |  | ) | const

For debug.

virtual void OsiBranchingObject::print | ( | const OsiSolverInterface * | = `NULL` | ) | const
| inline virtual

Print something about branch - only if log level high.

Definition at line 392 of file OsiBranchingObject.hpp.

## Member Data Documentation

double OsiBranchingObject::value_
| protected

Current value - has some meaning about branch.

Definition at line 396 of file OsiBranchingObject.hpp.

const OsiObject* OsiBranchingObject::originalObject_
| protected

Pointer back to object which created.

Definition at line 399 of file OsiBranchingObject.hpp.

int OsiBranchingObject::numberBranches_
| protected

Number of branches.

Definition at line 403 of file OsiBranchingObject.hpp.

short OsiBranchingObject::branchIndex_
| protected

The state of the branching object.

i.e. branch index This starts at 0 when created

Definition at line 408 of file OsiBranchingObject.hpp.

The documentation for this class was generated from the following file:

- /tmp/Clp-1.17.6/Osi/src/Osi/OsiBranchingObject.hpp